# RCS: @(#) $Id$

package require treectrl


proc item {parent text} {
	set T .f2.f1.t
	set i [$T item create]
	if {$parent == "root"} {
		$T item hasbutton $i yes
	}
	$T item lastchild $parent $i
	$T item style set $i 0 s1
	$T item text $i 0 $text
	$T item state set $i !pressed
	$T item state set $i disk
	return $i
}



proc toggle {w item mode} {
	if {[string range $mode end-3 end] eq "_all"} {
		set mode [string trimright $mode "_all"]

		set i [$w index $item]
		if {[catch {set last [$w index "$item nextsibling"]}]} {
			set last ""
		}
		while {$i ne "" && ($last eq "" || [$w compare $i < "$item nextsibling"])} {
			toggle $w $i $mode
			set i [$w index "$i next"]
		}
	} else {
		foreach s [list !disk !disk_first !cdrom !no $mode] {
			$w item state set $item $s
		}
	}
}

proc toggle {w item mode} {
	set first $item
	set last $item
	if {[string range $mode end-3 end] eq "_all"} {
		set mode [string range $mode 0 end-4]
		while {[$w index "$last lastchild"] ne ""} {
			set last [$w index "$last lastchild"]
		}
	}
	$w item state set $first $last [list !disk !disk_first !cdrom !no $mode]
}

proc DemoInstall {} {

	set T .f2.f1.t

	# get background color for buttons
	button .b
	set bgColor [.b cget -bg]
	destroy .b

	# load icons
	image create photo install_disk_button -data {R0lGODlhHQANAMIAAICAgMDAwAAAAP///wCAAP///////////yH5BAEKAAcALAAAAAAdAA0AAAM7eLrc/jDKSSu4OOOqQPhg+AGCNZxoel4l5YkhEbCLYNvNC4d0jeczTSbYqj08KhXRImwWKbeo9MmpRhIAOy==}

	image create photo install_disk_first_button -data {R0lGODlhHQANAMIAAICAgMDAwAAAAP//////AACAAP///////yH5BAEKAAcALAAAAAAdAA0AAANIeLrc/jDKB6q9djIQuv8dIGiHYApDqqrVOJkEIYBdEbSaEMu0hysnEwMmw1huoqGwoZOtVkjXQjqMCYwXqqQZ7C5JQZJ4LEkAADs=}

	image create photo install_cdrom_button -data {R0lGODlhHQANAMIAAICAgAAAAP//AMDAwAD//wD/AP///////yH5BAEKAAcALAAAAAAdAA0AAANLeLrc/hCECaBtEggx8r0BQWxDGXwRUIzcYAAV2gRDUWSGKc9lERg03WwyeQQ7AQBBODw9YKXcQECAQZxXV6nm2zkyW4/3S4yNz58EADs=}

	image create photo install_no_button -data {R0lGODlhHQANAKEAAIAAAAAAAP///////yH5BAEKAAIALAAAAAAdAA0AAAInlI+py+0PowAgUaloNRrn23lfuASm+ZDMmWpbE7SVKpI0diG5yC8FADs=}

	image create photo install_disk_menu -data {R0lGODlhHQANAMIAAICAgMDAwAAAAP///wCAAP///////////yH5BAEKAAcALAAAAAAdAA0AAAM4eLrc/jBKCKq9djIQuv8dIGgHMJxoelajxoEfEbDkC3+0O2PX3k4clcpX4xl/GoFyyVySntCoJgEAOy==}

	image create photo install_disk_all_menu -data {R0lGODlhHQANAMIAAAAAAICAgP///8DAwACAAP///////////yH5BAEKAAcALAAAAAAdAA0AAANPeLrc/jA2QCkMOOu8QBAB8ARDaZ5lqAACKzafIM80qB4e+DIkehIDzKtigfl8QsmCtNkEb8TdclCrPYefG6/J3blaj6i4uMpKlZEoev1IAAA7}

	image create photo install_disk_first_menu -data {R0lGODlhHAANAMIAAICAgMDAwAAAAP//////AACAAP///////yH5BAEKAAcALAAAAAAcAA0AAANCeLrc/jDKBqq9di4Quv8dIGiHYApDqqbVOJkEIYBBEbSaEMt0KOY6GaZy++ViqFWq6Hohh5amU3aqmkiKKnbLZSQAADs=}

	image create photo install_cdrom_menu -data {R0lGODlhHQANAMIAAICAgP//AMDAwAAAAACAAAD//////////yH5BAEKAAcALAAAAAAdAA0AAANQeLoL7izK6UIQAozJIyCFhQnG1nWAAF5kBpxUIROOkQkmzKQYYJQpjc4T9JVGueEhSBoMQLKkMmUTBAoEl3JXtV4J0q0DYxFuJ07n68w+JQAAOy==}

	image create photo install_cdrom_all_menu -data {R0lGODlhHQANAMIAAICAgP//AMDAwAAAAACAAAD//////////yH5BAEKAAcALAAAAAAdAA0AAANjeLoL7izK6UIQAgw5ep8KQBQWJhgbMwCGBh6AMF5nBqgoCgJFTziGjCClWLWIkRiGhYq5Fp4PxckcmJAvhvPUGfWQUay2JggUCDYV60kJYixn7CAn1iotbOi6HoneOFFZgoIJADs=}

	image create photo install_no_menu -data {R0lGODlhHQANAIAAAIAAAP///yH5BAEKAAEALAAAAAAdAA0AAAIjjI+py+0NQIoPUhNlZTn0bX1gODrZVU6UmHooW6KY1tb2VgAAOy==}


	# configure tree
	$T configure -showbuttons yes -showlines yes -showheader no \
		-itemheight 20 -selectmode none -indent 35 -selectmode browse \
		-showroot yes -showrootbutton no

	# configure column
	$T column create -text Test -expand yes

	# some user-defined states
	$T state define pressed
	$T state define disk
	$T state define disk_first
	$T state define cdrom
	$T state define no

	# elements
	$T element create button border -relief {raised {!pressed} sunken {pressed}} \
			-width 10 -height 10 -filled yes -thickness 1 -background $bgColor
	$T element create image image -width 35 -height 20 -image {
		install_disk_button {disk}
		install_disk_first_button {disk_first}
		install_cdrom_button {cdrom}
		install_no_button {no}
	}
	$T element create sel rect	-showfocus yes \
				-fill {lightblue {selected focus} gray {selected !focus}}
	$T element create text text

	# style
	$T style create s1
	$T style elements s1 {button image sel text}
	$T style layout s1 button -union {image} -iexpand ns
	$T style layout s1 image -expand n
	$T style layout s1 sel -union {text} -iexpand ns -ipadx 2
	$T style layout s1 text -expand ns -iexpand we -squeeze x -padx {5 0}

	# create the entries
	$T item style set 0 0 s1
	$T item text 0 0 "Microsoft Office"
	$T item state set 0 !pressed 
	$T item state set 0 disk

	set i1 [item root "Microsoft Word for Windows"]
		set i11 [item $i1 "Help"]
		set i12 [item $i1 "Wizard and Templates"]
	set i2 [item root "Microsoft Excel for Windows"]
		set i21 [item $i2 "Help"]
		set i22 [item $i2 "Wizard and Templates"]


	# bindings to operate the button
	bind Install <ButtonPress-1> {
		set id [%W identify %x %y]
		if {$id eq ""} {
			return
		}
		if {[lindex $id 0] eq "item"} {
			foreach {- item - column - element} $id {}
			if {$column == 0 && $element == "image"} {
				# simulate the button press
				%W item element configure $item 0 image -height 19
				%W item state set $item pressed
				# menu
				destroy ._m_
				menu ._m_ -tearoff 0 -bd 1
				foreach {image label command} {
							disk "Run from My Computer" ""
							disk_all "Run all from My Computer" ""
							- - -
							cdrom "Run from CD" ""
							cdrom_all "Run all from CD" ""
							- - -
							disk_first "Installed on First Use" ""
							- - -
							no "Not available" ""	} {
					if {$image == "-"} {
						._m_ add separator
					} else {
						._m_ add command -image install_${image}_menu \
								-label $label -compound left \
								-command "toggle %W $item $image"
					}
				}

				# show a normal button when the menu is unmapped
				bind ._m_ <Unmap> "%W item state set $item !pressed
					%W item element configure $item 0 image -height 20"

				# display it in the right place
				foreach {x - - y} [%W item bbox $item $column $element] break
				tk_popup ._m_ [expr [winfo rootx %W]+$x] [expr [winfo rooty %W]+$y]

				if {$::thisPlatform ne "unix"} {
					%W item state set $item !pressed
					%W item element configure $item 0 image -height 20
				}
				return -code break

			} elseif {[lindex $id 2] eq "button"} {
#				%W item toggle [lindex $id 1]
			}
		}
	}

	bindtags $T [list $T Install TreeCtrl [winfo toplevel $T] all]

	return
}
