console show

package require Tk
package require treectrl 2.0

# button press 1 event
proc OptionButton1 {T x y} {
    focus $T
    set id [$T identify $x $y]
    if {[lindex $id 0] eq "header"} {
        TreeCtrl::ButtonPress1 $T $x $y
    } elseif {$id eq ""} {
    } else {
        array set ids $id
        set item $ids(item)
        $T selection modify $item all
        $T activate $item
        # toggle element when user clicks element eImage
        if {[info exists ids(elem)] && $ids(elem) eq "eImage"} {
            $T item state set $item ~on
        }
        #puts ---
        #puts $id
        #parray ids
    }
    return
}

# Open a dialog for creating a new or opening a database.
proc main {} {
    . configure -borderwidth 2 -relief sunken
    catch {destroy .t}
    catch {destroy .sv}
    catch {destroy .sh}
    catch {destroy .c}
    set t .t
    treectrl $t

    $t configure -showroot no -showbuttons no -showlines yes \
            -showheader yes -borderwidth 0 -highlightthickness 0

    # create the scrollbars
    set sh .sh
    scrollbar $sh -orient horizontal -command "$t xview"
    $t notify bind $sh <Scroll-x> { %W set %l %u }
    bind $sh <ButtonPress-1> "focus $t"

    set sv .sv
    scrollbar $sv -orient vertical -command "$t yview"
    $t notify bind $sv <Scroll-y> { %W set %l %u }
    bind $sv <ButtonPress-1> "focus $t"

    set ::showlines 1
    set check .c
    checkbutton $check \
            -text "showlines (treecolumn = \{\})" \
            -command ".t configure -showlines \$::showlines" \
            -variable showlines

    grid columnconfigure . 0 -weight 1
    grid rowconfigure . 0 -weight 1
    grid configure $t -row 0 -column 0 -sticky news
    grid configure $sh -row 1 -column 0 -sticky we
    grid configure $sv -row 0 -column 1 -sticky ns
    grid configure $check -row 2 -column 0 -sticky w

    # create columns
    $t column create -tag c1 -text column1

    # must specify -treecolumn or eImage will not be given in
    # $t identify
    $t configure -treecolumn {} -showlines $::showlines

    # create images
    set checked [image create photo -file checked.gif]
    set unchecked [image create photo -file unchecked.gif]

    # define states
    $t state define check
    $t state define on

    # create elements
    $t element create eRect rect -showfocus yes \
        -fill [list \
            lightblue {selected focus} \
            gray {selected !focus} \
        ]
    $t element create eText text -lines 1
    $t element create eImage image -image [list \
        $checked {check on} \
        $unchecked {check} \
    ]

    # create styles
    set s [$t style create s1]
    $t style element $s {eRect eImage eText}
    $t style layout $s eImage -padx {0 4} -expand ns
    $t style layout $s eText -padx {2 6} -expand ns
    $t style layout $s eRect -union {eText} -detach no -iexpand ns -ipadx 2

    $t configure -defaultstyle s1
    # insert a few items
    for {set c 0} {$c < 100} {incr c} {
        set i [$t item create]
        $t item element configure $i c1 eText -text "checkbox ($c)"
        $t item state set $i check
        $t item lastchild root $i
        if {$c == 0} {
            $t see $i
            $t activate $i
        }
    }

    bind $t <ButtonPress-1> [list OptionButton1 %W %x %y]
    focus $t
}

main
